//
//
//	Basic text-file lexer class
//
//											(C) 1997 JoOl


#ifndef _BASIC_LEXER_H_
#define _BASIC_LEXER_H_

#include "LexerText.h"


// Lexeme ids
enum
{
	LX_CHAR_COMMENT = LX_CHAR_LAST+1
};


// Tokens in NFF files
enum
{
	LX_TOKEN_VIEW =  0x100,
	LX_TOKEN_FROM,
	LX_TOKEN_AT,
	LX_TOKEN_UP,
	LX_TOKEN_ANGLE,
	LX_TOKEN_HITHER,
	LX_TOKEN_RESOLUTION,
	LX_TOKEN_LIGHT_LOCATION,
	LX_TOKEN_BACKGROUND_COLOR,
	LX_TOKEN_MATERIAL_PROPERTIES,
	LX_TOKEN_CYLINDER,
	LX_TOKEN_SPHERE,
	LX_TOKEN_POLYGON,
	LX_TOKEN_POLYGON_PATCH
};



class					LexerBasic : public LexerText
{

	void				SetCharset();
	void				SetLexemes();
	void				SetSymbols();

public:

	LexerBasic(int32, int32);
	~LexerBasic();

	virtual bool		SetInput(entry_ref& );

	virtual bool		NextToken(uint32& );
};



#endif	/* _BASIC_LEXER_H_ */

