//
//
//	NFF file parser class
//
//											(C) 1997 JoOl


#ifndef _NFF_PARSER_H_
#define _NFF_PARSER_H_


#include "ParserText.h"
#include "LexerNff.h"


class						ParserNff: public ParserText
{
	bool					ParseVector3f(float& , float& , float& );

	bool					ParseView();
	bool					ParseLight();
	bool					ParseColor();
	bool					ParseMaterial();
	bool					ParseCylinder();
	bool					ParseSphere();
	bool					ParsePolygon();
	bool					ParsePatch();


public:

	ParserNff(bool, int32 = LEXER_BUFLEN, int32 = LEXER_LEXMLEN);
	~ParserNff();

	virtual bool			CheckType();

	virtual bool			Parse();
};


#endif	/* _NFF_PARSER_H_ */

